﻿@page "/referees"
@using Models.RefereeData
@using Business.Repository.IRepository
@inject IRefereeRepository RefereeRepository
@inject IJSRuntime JsRuntime
@inject NavigationManager NavigationManager
@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-4">
    <div class="col-8">
        <h4 class="card-title text-info">Referees</h4>
    </div>
    <div class="col-3 offset-1">
        <NavLink href="referees/create" class="btn btn-primary form-control">Add new referee</NavLink>
    </div>
</div>
<div class="row mt-4">
    <div class="col-12">
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th class="text-center">Name</th>
                    <th width="10%">
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Referees.Any())
                {
                    foreach (var referee in Referees)
                    {
                        <tr>
                            <td class="text-center">@referee.Name @referee.Surname</td>
                            <td>
                                <NavLink href="@($"referees/edit/{referee.Id}")" class="btn btn-primary">Edit</NavLink>
                                <button class="btn btn-danger" @onclick="()=>HandleDelete(referee.Id)">Delete</button>
                            </td>
                        </tr>
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>

<DeleteConfirmation IsParentComponentProcessing="IsProcessing" ConfirmationChanged="ConfirmDelete_Click"></DeleteConfirmation>

@code {
    private IEnumerable<RefereeDTO> Referees { get; set; } = new List<RefereeDTO>();
    private int? DeleteRefereeId { get; set; } = null;
    private bool IsProcessing { get; set; } = false;
    private string Name { get; set; }

    protected async override Task OnInitializedAsync()
    {
        Referees = await RefereeRepository.GetAll();
    }

    private async Task HandleDelete(int refereeId)
    {
        DeleteRefereeId = refereeId;
        await JsRuntime.InvokeVoidAsync("ShowDeleteConfirmationModal");
    }
    public async Task ConfirmDelete_Click(bool isConfirmed)
    {
        IsProcessing = true;
        if (isConfirmed && DeleteRefereeId != null)
        {
            var result = await RefereeRepository.Delete(DeleteRefereeId.Value);

            if (result == 0)
            {
                await JsRuntime.ToastrError("Referee is used and cannot be deleted!");
            }
            else
            {
                await JsRuntime.ToastrSuccess("Referee deleted successfully!");
                Referees = await RefereeRepository.GetAll();
            }

        }
        await JsRuntime.InvokeVoidAsync("HideDeleteConfirmationModal");
        IsProcessing = false;
    }
}
